<!--
/**
 * ----------------------------------------------------------------
 * @Author     : Mathieu Boutin
 *
 * @File       : TooltipContainer.vue
 * @Created_at : 26/03/2022
 * @Update_at  : 26/03/2022
 * ----------------------------------------------------------------
 */
-->

<style type="text/css" src="./css/TooltipContainer.css" scoped></style>

<script>

    import Tooltip from "../Tooltip";

    import TypeManager from "../../service/Manager/TypeManager";
    import ObjectManager from "../../service/Manager/ObjectManager";
    import TriggerConstant from "../../service/Constant/TriggerConstant";
    import OptionsService from "../../service/Options/OptionsService";

    export default {
        name: "TooltipContainer",

        components: {Tooltip},

        props: {
            options: {
                type: Object,
                default: () => {
                    return {};
                }
            }
        },

        data: () => {
            return {
                element: null,

                timeout: null, // variable which stock timeout show, if we need to clear it.

                tooltip: {
                    show: false,

                    options: {
                        width: {
                            min: null,
                            max: null
                        },

                        position: {
                            left: null,
                            top: null
                        },

                        trigger: null
                    }
                }
            }
        },

        watch: {
            options: {
                handler: function (newOptions) {
                    this.prepareOptions(newOptions);
                }
            }
        },

        // Life Cycle : Created
        created() {
            this.prepareOptions(this.options);
        },

        // Life Cycle : Mounted
        mounted() {
            this.initMounted();
        },

        // Life Cycle : Before Destroy
        beforeDestroy() {
            // Destroy element
            if (!TypeManager.isNull(this.element)) {
                this.element.onmouseenter = null;
                this.element.onmouseleave = null;
            }
            this.element = null;

            // Destroy timeout
            clearTimeout(this.timeout);
            this.timeout = null;

            // Destroy tooltip
            this.tooltip = null;
        },

        methods: {
            // --------------------------------
            // Life cycle

            /**
             * Init in life cycle : Mounted.
             */
            initMounted() {
                // ----------------
                // Prepare

                // Prepare element
                this.element = this.prepareElement();

                this.prepareTrigger();
            },

            // --------------------------------
            // Prepare

            /**
             * Prepare element HTML.
             *
             * @returns {*}
             */
            prepareElement() {
                // ----------------
                // Prepare

                // If there is no slot, mean that it's the default div which is used.
                // That happen when no slot called when we call the tooltipContainer.
                if (TypeManager.isEmpty(this.$slots)) {

                    // ObjectManager.get get the key Element if the key exists, otherwise it returns null.
                    return ObjectManager.get(this.$refs, 'Element');
                }

                // ----------------
                // Process

                // Get slot element
                let element = ObjectManager.get(this.$slots, 'Element');

                // Get first element of slot element
                element = TypeManager.isEmpty(element) ? null : element[0];

                // Get element html of element.
                return ObjectManager.get(element, 'elm');
            },

            /**
             * Prepare options.
             *
             * @param options
             */
            prepareOptions(options) {
                // ----------------
                // Vars

                let defaultOptions = {
                    width: {
                        min: null,
                        max: null
                    },

                    trigger: TriggerConstant.HOVER,
                }

                // ----------------
                // Prepare

                options = OptionsService.prepareOptions(options, defaultOptions);

                // ----------------
                // Process

                // Size
                this.tooltip.options.width.max = options.width.max - 10; // remove 10px for padding
                this.tooltip.options.width.min = options.width.min - 10; // remove 10px for padding

                // Trigger
                this.tooltip.options.trigger = options.trigger;
            },

            /**
             * Prepare trigger.
             */
            prepareTrigger() {
                // ----------------
                // Prepare

                // Focus
                if (this.tooltip.options.trigger === TriggerConstant.FOCUS) {
                    this.element.onfocus = (event)=>{
                        clearTimeout(this.timeout);
                        console.log("event ", event);
                        this.timeout = setTimeout(() => {
                            // Show tooltip.
                            this.tooltip.show = true;
                        }, 500)
                    }

                    this.element.onblur = ()=>{
                        clearTimeout(this.timeout);

                        this.timeout = setTimeout(() => {
                            // Show tooltip.
                            this.tooltip.show = false;
                        }, 500)
                    }
                    return;
                }

                // Default : Hover.

                // If it's hover trigger, we add onmouseenter and onmouseleave event.
                this.element.onmouseenter = (event) => {
                    clearTimeout(this.timeout);

                    this.tooltip.options.position.top = event.clientY;
                    this.tooltip.options.position.left = event.clientX;

                    this.timeout = setTimeout(() => {
                        // Show tooltip.
                        this.tooltip.show = true;
                    }, 500)
                }

                this.element.onmouseleave = () => {
                    // Clear timeout if we leave the element before it shows the tooltip.
                    clearTimeout(this.timeout);

                    this.timeout = setTimeout(() => {
                        // Clear tooltip.
                        this.tooltip.show = false;
                    }, 500)
                }
            },

            // --------------------------------
            // Setters

            // --------------------------------
            // Utils

            // --------------------------------
            // Events

            /**
             * Event on : Mouse enter.
             */
            mouseEnterEvent() {
                clearTimeout(this.timeout);
            },

            /**
             * Event on : Mouse Leave.
             */
            mouseLeaveEvent() {
                this.timeout = setTimeout(() => {
                    this.tooltip.show = false;
                }, 500)
            },

            /**
             * Event on : Focus.
             */
            focusEvent() {
                clearTimeout(this.timeout);
            },

            /**
             * Event on : Blur.
             */
            blurEvent() {
                this.timeout = setTimeout(() => {
                    this.tooltip.show = false;
                }, 500)
            }
        }
    }
</script>

<template>
    <div class="tooltip-container">

        <!-- Element HTML -->
        <slot name="Element">
            <div ref="Element"> Div Par défaut</div>
        </slot>

        <!-- Tooltip -->
        <transition name="transition-tooltip">
            <Tooltip
                ref="Tooltip"

                v-if="tooltip.show"

                :options="tooltip.options"

                @mouseenter="mouseEnterEvent"
                @mouseleave="mouseLeaveEvent"
                @focus = "focusEvent"
                @blur = "blurEvent"
            >
                <template slot="Tooltip">
                    <slot name="Tooltip">Tooltip défaut</slot>
                </template>
            </Tooltip>
        </transition>
    </div>
</template>
